<template>
  <section class="vlue-container"
    v-if="props"
    :class="[
      props.align,
      props.cssClass,
      { 'leaf'    : ( !props.pageContainers && !props.childContainers ) },
      { 'content' : (  props.contentComponents                        ) },
      { 'pages'   : (  props.pageContainers                           ) },
      { 'hide-on-mobile' : ( props.hideOnMobile                       ) },
    ]"
    :style="getStyle()">
    <div class="vlue-container-background" :style="getContainerBackgroundStyle()"></div>
    <container
      v-for="(container, index) in props.childContainers"
      :props="container"
      :index="index"
      :key="index">
    </container>
    <container
      v-if="props.pageContainers"
      :class="editPage ? 'vlue-selected-area' : 'vlue-not-selected-area'"
      :props="currentPageContainer">
    </container>
    <content-component
      v-for="(content, index) in props.contentComponents"
      :pathway="content.pathway"
      :props="content.props"
      :key="index">
    </content-component>
    <div class="vlue-container-interface" v-if="!websiteGeneration">
      <div class="vlue-container-selection" :class="{ selected : props.selected }"></div>
      <input
        v-for="value in ['up','left','down','right']"
        class="vlue-container-button vlue-container-button-edge"
        :class="value"
        type="button"
        :value="getButtonValue()"
        v-on:click="buttonPressed($event, value)">
      <input
        class="vlue-container-button vlue-container-button-center"
        type="button"
        :value="getButtonValue()"
        v-on:click="buttonPressed($event, 'center')">
      <div class="vlue-container-highlight"></div>
    </div>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'
import contentComponent from './Content.vue'
import store from '../../store/store'
import { mapState, mapGetters } from 'vuex'

export default Vue.extend({
  name: "vlue-container",
  computed: {
    ...mapState([
      'mode',
      'website',
      'editPage',
      'portraitNotLandscape',
      'websiteGeneration',
    ]),
    ...mapGetters([
      'currentPageContainer',
    ]),
  },
  props: {
    props: Object,
    index: Number
  },
  components: {
    contentComponent,
  },
  methods: {
    getStyle() {
      return {
        'grid-template-columns': (
            // for grid containers, set grid cell size based on size attribute
            this.props.align == 'grid'
          ? 'repeat(auto-fill, minmax(' + this.props.gridCellSize + ', 1fr))'
          : undefined
        ),
        'flex-wrap': (
            // boolean used for preventing child containers from row breaking
            this.props.disableContentWrap
          ? 'nowrap'
          : undefined
        ),
        // flex grow shrink basis
        'flex': (
            // special case for container holding all pages
            ((this.$parent as any).props || {}).pageContainers
          ? '0 0 100%'
            // for containers stacked in a column, only let the last container expand
          : ((this.$parent as any).props || {}).align == 'column'
          ? ((this.$parent as any).props.childContainers.length - 1 == this.index ? 1 : 0) + ' 1 auto'
            // for containers with a size value, apply it and set a low grow value
          : this.props.size
          ? '1 1 ' + this.props.size
            // for containers with no size value, set a large grow value
          : '100 1 0'
        ),
        // uses padding and margin to get content inside the container background element
        'padding': (
          'calc(' + (this.props.padding || '0px') + ' + ' + (this.props.margin || '0px') + ')'
        ),
      };
    },
    getContainerBackgroundStyle() {
      return {
        'background-image' : this.props.bgImage
                           ? 'url(' + this.props.bgImage + ')'
                           : undefined,
        'background-color' : this.props.bgcolor,
        'margin'           : this.props.margin,
        'border-radius'    : this.props.borderRadius,
        'border-color'     : this.props.borderColor,
        'border-width'     : this.props.borderWidth,
        'border-style'     : this.props.borderStyle,
        'box-shadow'       : this.props.shadowSize
                           ? ('0 ' + this.props.shadowSize
                             + ' ' + this.props.shadowSize + ' #0007')
                           : undefined,
      };
    },
    getButtonValue() {
      switch (this.mode) {
        case 'create' : return '+';
        case 'edit'   : return '~';
        case 'move'   : return '#';
        case 'delete' : return '-';
      }
    },
    buttonPressed($event, value) {
      switch (this.mode) {
        case 'create':
          store.commit('showCreatePopup', {
            current: this.props,
            direction: value,
            clickPosition: {
              x: $event.clientX,
              y: $event.clientY,
            }
          });
          break;
        case 'edit':
          store.commit('selectContainer', {
            current: this.props,
            currentVueObject: this,
          });
          break;
        case 'move':
          store.dispatch('changeWebsiteState', {
            mutation: 'moveContainer',
            params: {
              current: this.props,
              currentVueObject: this,
              direction: value,
            },
          });
          break;
        case 'delete':
          store.dispatch('changeWebsiteState', {
            mutation: 'removeContainer',
            params: {
              current: this.props,
              parent: this.$parent,
              index: this.$props.index,
              moving: false,
            },
          });
          break;
      }
    }
  },
  beforeCreate() {
    // this solves the 'circular references between components' issue
    // which is caused by using recursive components
    if (this.$options.components) {
      this.$options.components.container = require('./Container.vue').default;
    }
  }
})
</script>

<style lang="scss">
  @import "../../style/vars.scss";

  .vlue-selected-layer.vlue-selected-area .vlue-container-interface,
  .vlue-selected-layer .vlue-selected-area .vlue-container-interface {
    display: block;
  }
  .vlue-selected-layer.vlue-selected-area .vlue-not-selected-area .vlue-container-interface,
  .vlue-container-interface {
    display: none;
  }
  .vlue-container {
    display: block;
    position: relative;
    min-height: 150px;
    min-width: 100px;
    &.row {
      display: flex;
      flex-wrap: wrap;
      > .vlue-container-interface .up,
      > .vlue-container-interface .down {
        height: $vlue-container-button-thickness-slim;
      }
    }
    &.column {
      display: flex;
      flex-direction: column;
      > .vlue-container-interface .left,
      > .vlue-container-interface .right {
        width: $vlue-container-button-thickness-slim;
      }
    }
    &.grid {
      display: grid;
    }
    &.pages {
      display: flex;
    }
    &.leaf {
      > .vlue-container-interface .up,
      > .vlue-container-interface .down {
        height: $vlue-container-button-thickness-thick;
      }
      > .vlue-container-interface .left,
      > .vlue-container-interface .right {
        width: $vlue-container-button-thickness-thick;
      }
    }
  }
  #app:not(.dev) .vlue-container {
    pointer-events: none;
    &.content {
      pointer-events: auto;
    }
  }
  .vlue-container-button-center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%,-50%);
    z-index: 1;
    border: none;
    background: transparent;
    width: 40px;
    height: 40px;
    border-radius: 50%;
    color: transparent;
    font-weight: bolder;
    transition: $vlue-transition-duration;
    pointer-events: none;
  }
  .dev.create .vlue-container.leaf:hover
  .vlue-container-button-center,
  .dev.create .vlue-container-button-edge:hover {
    background: $vlue-color-create;
    &:active {
      color: $vlue-color-create;
    }
  }
  .dev.edit .vlue-container.leaf:hover
  .vlue-container-button-center,
  .dev.edit .vlue-container-button-edge:hover {
    background: $vlue-color-edit;
    &:active {
      color: $vlue-color-edit;
    }
  }
  .dev.move .vlue-container.leaf:hover
  .vlue-container-button-center,
  .dev.move .vlue-container-button-edge:hover {
    background: $vlue-color-move;
    &:active {
      color: $vlue-color-move;
    }
  }
  .dev.delete .vlue-container.leaf:hover
  .vlue-container-button-center,
  .dev.delete .vlue-container-button-edge:hover {
    background: $vlue-color-delete;
    &:active {
      color: $vlue-color-delete;
    }
  }
  .dev .vlue-container.leaf:hover
  .vlue-container-button-center {
    pointer-events: auto;
    color: white;
    box-shadow: 0 5px 5px rgba(0,0,0,0.5);
    width: 50px;
    height: 50px;
    &:hover {
      width: 60px;
      height: 60px;
    }
    &:active {
      background: white;
      transition: 0s;
      width: 50px;
      height: 50px;
    }
  }
  .vlue-container-button-edge {
    pointer-events: none;
    z-index: 1;
    font-weight: bolder;
    border: none;
    border-radius: 5px;
    background: transparent;
    color: transparent;
    position: absolute;
    line-height: 0px;
    transition: $vlue-transition-duration;
    &.up {
      top: 2px;
      left: 50%;
      transform: translateX(-50%);
      max-width: $vlue-container-button-length-max;
      width: $vlue-container-button-length;
      height: $vlue-container-button-thickness;
    }
    &.down {
      bottom: 2px;
      left: 50%;
      transform: translateX(-50%);
      max-width: $vlue-container-button-length-max;
      width: $vlue-container-button-length;
      height: $vlue-container-button-thickness;
    }
    &.left {
      left: 2px;
      top: 50%;
      transform: translateY(-50%);
      max-height: $vlue-container-button-length-max;
      height: $vlue-container-button-length;
      width: $vlue-container-button-thickness;
    }
    &.right {
      right: 2px;
      top: 50%;
      transform: translateY(-50%);
      max-height: $vlue-container-button-length-max;
      height: $vlue-container-button-length;
      width: $vlue-container-button-thickness;
    }
  }
  .dev .vlue-container-button-edge {
    pointer-events: auto;
    &:hover {
      color: white;
      &.up, &.down {
        width: $vlue-container-button-length-max;
      }
      &.left, &.right {
        height: $vlue-container-button-length-max;
      }
      &:active {
        background: white;
        transition: 0s;
      }
    }
  }
  .vlue-container-highlight,
  .vlue-container-selection {
    pointer-events: none;
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    transition: $vlue-transition-duration;
    box-sizing: border-box;
  }
  .vlue-container-highlight {
    opacity: 0.1;
  }
  .vlue-container-selection {
    margin: 3px;
    border: 1.5px dotted transparent;
  }
  .dev {
    .vlue-container:hover > .vlue-container-interface .vlue-container-highlight {
      background: rgba(255,255,255,0.25);
    }
    .vlue-container-button:hover {
      box-shadow: 0 5px 5px rgba(0,0,0,0.5);
    }
    &.create .vlue-container-button:hover ~ .vlue-container-highlight {
      background: $vlue-color-create;
    }
    &.edit .vlue-container-button:hover ~ .vlue-container-highlight {
      background: $vlue-color-edit;
    }
    &.move .vlue-container-button:hover ~ .vlue-container-highlight {
      background: $vlue-color-move;
    }
    &.move .vlue-container-selection.selected ~ .vlue-container-highlight {
      background: #657fb3;
      opacity: 0.5;
      background-size: 30px;
      background-image: url('../../../public/core/images/stripePattern.png');
      animation: linear infinite 1s move-selection;
    }
    &.delete .vlue-container-button:hover ~ .vlue-container-highlight {
      background: $vlue-color-delete;
    }
    &.create .vlue-container-selection.selected {
      border-color: $vlue-color-create;
    }
    &.edit .vlue-container-selection.selected {
      border-color: $vlue-color-edit;
    }
    &.move .vlue-container-selection.selected {
      border-color: $vlue-color-move;
    }
    &.delete .vlue-container-selection.selected {
      border-color: $vlue-color-delete;
    }
  }
  .vlue-container-background {
    position: absolute;
    left: 0;
    top: 0;
    right: 0;
    bottom: 0;
    background-size: cover;
    background-position: center;
  }

  @keyframes move-selection {
    0% {
      opacity: 0.25;
      background-position: 0 0;
    }
    50% {
      opacity: 0.5;
      background-position: 0 -15px;
    }
    100% {
      opacity: 0.25;
      background-position: 0 -30px;
    }
  }
</style>
